//
//  PSMWebSpiderPlugin.h
//  Pandora
//
//  Created by John Pannell on 2/16/06.
//  Copyright 2006 Positive Spin Media. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "PandoraPlugin.h"


@interface PSMConsecutiveNumbersPlugin : NSWindowController<PandoraPlugin> {
    
    // UI
    IBOutlet NSImageView    *icon;
    
    // config options
    NSSet                   *_MIMETypes;
    int                     _maxFileSize;
    int                     _minFileSize;
}

// for identification
+ (NSImage *)icon;
+ (NSString *)name;
+ (NSString *)description;
+ (NSString *)category;
+ (NSString *)prompt;

// UI
- (IBAction)endConfig:(id)sender;

// accessors
- (void)setMIMETypes:(NSSet *)types;
- (void)setMinFileSize:(int)kilobytes;
- (void)setMaxFileSize:(int)kilobytes;

// for spider
- (BOOL)contentFromDifferentServers;
- (int)linkDepth;
- (NSMutableArray *)preprocessURLOrKeyword:(NSString *)string;
- (BOOL)shouldPursueResourceWithURL:(NSString *)url MIMEType:(NSString *)mime andExpectedFileSize:(long long)size withReason:(NSString **)reason;
- (NSDictionary *)postprocessURL:(NSString *)url;

// authentication
- (NSArray *)authenticationInfo;
- (BOOL)parseAuthSuccessPage;
- (NSString *)authSuccessURLFragment;

@end
