//
//  PSMYahooImageSearchPlugin.h
//  Pandora
//
//  Created by John Pannell on 1/10/07.
//  Copyright 2006 Positive Spin Media. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "PandoraPlugin.h"

@interface PSMYahooImageSearchPlugin : NSWindowController<PandoraPlugin> {
    
    // UI
    IBOutlet NSImageView    *icon;
    IBOutlet NSTextField    *siteField;
    
    // config options
    NSSet                   *_MIMETypes;
    int                     _maxFileSize;
    int                     _minFileSize;
    
    // preferences
    NSMutableDictionary     *_preferences;
}

// for identification
+ (NSImage *)icon;
+ (NSString *)name;
+ (NSString *)description;
+ (NSString *)category;
+ (NSString *)prompt;

// accessors
- (void)setMIMETypes:(NSSet *)types;
- (void)setMinFileSize:(int)kilobytes;
- (void)setMaxFileSize:(int)kilobytes;

// prefs
- (IBAction)recordPreferences:(id)sender;

// for spider
- (BOOL)contentFromDifferentServers;
- (int)linkDepth;
- (NSMutableArray *)preprocessURLOrKeyword:(NSString *)string;
- (BOOL)shouldPursueResourceWithURL:(NSString *)url MIMEType:(NSString *)mime andExpectedFileSize:(long long)size withReason:(NSString **)reason;
- (NSDictionary *)postprocessURL:(NSString *)url;

// authentication
- (NSArray *)authenticationInfo;
- (BOOL)parseAuthSuccessPage;
- (NSString *)authSuccessURLFragment;

// Yahoo safe search pref setting
- (IBAction)setSafeSearchPref:(id)sender;

@end
