//
//  FileController.h
//  NetScrape
//
//  Created by John Pannell on Sun Oct 24 2004.
//  Copyright (c) 2004 Positive Spin Media. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "ThumbnailMatrix.h"
#import "PSMWebFile.h"


@interface FileController : NSObject {
    
    // bound values (for display in tabs)
    NSObjectController          *_objectController;  // for bindings
    BOOL                        _isProcessing;
    NSImage                     *_icon;
    int                         _objectCount;
    BOOL                        _isDone;            // nothing left to get
    BOOL                        _userPaused;        // paused by user
    BOOL                        _sleepPaused;       // paused by putting computer to sleep
    
    // the models
    NSMutableArray              *_scrapedFiles;
    
    NSMutableArray              *fileNames;         // full paths for each image
    NSString                    *myString;          // directory path entered by user
    ThumbnailMatrix             *myThumbnailMatrix;
    BOOL                        _scrapeSubdirectories;
}

// config
- (ThumbnailMatrix *)thumbnailMatrix;
- (void)setThumbnailMatrix:(ThumbnailMatrix *)matrix;

// accessors
- (NSString *)rootString;
- (NSString *)pluginName;
- (BOOL)isProcessing;
- (void)setIsProcessing:(BOOL)value;
- (BOOL)isDone;
- (void)setIsDone:(BOOL)flag;
- (int)objectCount;
- (void)setObjectCount:(int)value;
- (NSImage *)icon;
- (void)setIcon:(NSImage *)icon;
- (NSMutableArray *)scrapedFiles;
- (void)setScrapedFiles:(NSMutableArray *)array;
- (NSString *)myString;

- (NSObjectController *)objectController;

// compatibility with Session object
- (void)pause:(id)sender;
- (void)resume:(id)sender;
- (void)pauseEngine;
- (void)resumeEngine;
- (void)stopEngine;

// functionality
- (id)initWithString:(NSString *)theString scrapeSubdirectories:(BOOL)subDirs;
- (void)startScript;
- (void)stopScript;
- (void)getFileListAtPath:(NSString *)thePath;
- (void)loadFile;
- (void)addScrapedFile:(PSMWebFile *)object;
- (void)setThumbnailMatrix:(ThumbnailMatrix *)matrix;
- (NSMutableArray *)fileNames;
- (BOOL)isProcessing;

@end
