//
//  PSMMIMEAssistant.h
//  Pandora
//
//  Created by John Pannell on 5/2/06.
//  Copyright 2006 Positive Spin Media. All rights reserved.
//

#import <Cocoa/Cocoa.h>
@class PSMPreferenceController;

@interface PSMMIMEAssistant : NSObject {
    NSMutableArray                      *_mimeList;
    IBOutlet NSOutlineView              *outlineView;
    IBOutlet NSTreeController           *mimeController;
    IBOutlet PSMPreferenceController    *prefController;
}
// Accessors
- (NSMutableArray *)mimeList;
- (NSSet *)defaultValues;
- (void)setDefaultValues:(NSSet *)values;

// Outline View Datasource
- (id)outlineView:(NSOutlineView *)outlineView child:(int)index ofItem:(id)item;
- (BOOL)outlineView:(NSOutlineView *)outlineView isItemExpandable:(id)item;
- (int)outlineView:(NSOutlineView *)outlineView numberOfChildrenOfItem:(id)item;
- (id)outlineView:(NSOutlineView *)outlineView objectValueForTableColumn:(NSTableColumn *)tableColumn byItem:(id)item;

// Outline View Delegate
- (void)outlineView:(NSOutlineView *)outlineView willDisplayCell:(id)cell forTableColumn:(NSTableColumn *)tableColumn item:(id)item;

// button state management
- (void)childButtonClick:(id)sender;
- (void)parentButtonClick:(id)sender;
- (void)setStateForParent:(NSString *)parentDescription;

@end

// quiet the compiler about using -observedObject for tree controller returned objects
@interface NSObject (QuietCompiler)
- (id)observedObject;
@end
