//
//  PSMPaymentController.m
//  Pandora
//
//  Created by John Pannell on 12/10/05.
//  Copyright 2005 Positive Spin Media. All rights reserved.
//

#import "PSMPaymentController.h"

@implementation PSMPaymentController
#pragma mark -
#pragma mark Begging
- (void)beg:(id)sender
{
    // non-registered user quit app - beg for money
    [NSApp beginSheet: begPanel
       modalForWindow: [NSApp mainWindow]
        modalDelegate: nil
       didEndSelector: nil
          contextInfo: nil];
    [NSApp runModalForWindow:begPanel];
    // Sheet is up here.
}

- (IBAction)quitApp:(id)sender
{
    // user cancelled
    [NSApp endSheet:begPanel];
    [begPanel orderOut:self];
    [NSApp replyToApplicationShouldTerminate:YES];
    [NSApp stopModal];
}

- (IBAction)purchaseNow:(id)sender
{
    // send to web for purchase
    [NSApp replyToApplicationShouldTerminate:NO];
    [NSApp endSheet:begPanel];
    [begPanel orderOut:self];
    [NSApp stopModal];
    // I cannot do this, as the app remains modal for some reason
    // [thePaymentController makePayment:self];
    [[NSRunLoop currentRunLoop] performSelector:@selector(makePayment:) target:self argument:self order:1 modes:[NSArray arrayWithObjects:@"NSDefaultRunLoopMode", nil]];
}

#pragma mark -
#pragma mark Buying
- (void)makePayment:(id)sender
{
    // clicked the button to pay me - confirmation message
    [NSApp beginSheet: paymentPanel
       modalForWindow: [NSApp mainWindow]
        modalDelegate: nil
       didEndSelector: nil
          contextInfo: nil];
    [NSApp runModalForWindow: paymentPanel];
    // Sheet is up here.
    [NSApp endSheet:paymentPanel];
    [paymentPanel orderOut:self];
}

- (IBAction)cancelPayment:(id)sender
{
    // user cancelled
    [NSApp stopModal];
}

- (IBAction)buyNow:(id)sender
{
    // send to web for purchase
    [NSApp stopModal];
    // is it an upgrade?
    if([[licenseType selectedCell] tag] == 2){
        // send to my server with preferred payment vendor and old reg code
        [[NSWorkspace sharedWorkspace] openURL:[NSURL URLWithString:[NSString stringWithFormat:@"http://www.positivespinmedia.com/shareware/Pandora/upgrade.php?vendor=%d&code=%@", [[paymentMethod selectedCell] tag], [[[NSUserDefaults standardUserDefaults] persistentDomainForName:@"com.positivespinmedia.netscrape"] objectForKey:@"NetScrape Registration Code"]]]];
        return;
    }
    
    // not upgrade; send to preferred vendor with price
    if([[paymentMethod selectedCell] tag] == 0){
        // paypal
        if([[licenseType selectedCell] tag] == 0){ // single license
            [[NSWorkspace sharedWorkspace] openURL:[NSURL URLWithString:@"https://www.paypal.com/cart/add=1&business=pandora@positivespinmedia.com&item_name=Pandora%20%5BSingle%5D&item_number=101&amount=29.95&image_url=http%3A//www.positivespinmedia.com/psmlogopp.gif&no_shipping=1"]];
        } else {// multi license
            [[NSWorkspace sharedWorkspace] openURL:[NSURL URLWithString:@"https://www.paypal.com/cart/add=1&business=pandora@positivespinmedia.com&item_name=Pandora%20%5BMulti%5D&item_number=102&amount=39.95&image_url=http%3A//www.positivespinmedia.com/psmlogopp.gif&no_shipping=1"]];
        }
    } else {
        // kagi
        [[NSWorkspace sharedWorkspace] openURL:[NSURL URLWithString:@"https://order.kagi.com/cgi-bin/store.cgi?storeID=6CYPD&&"]];
    }
}

@end
