//
//  PSMRegistrationController.m
//  Pandora
//
//  Created by John Pannell on 8/3/06.
//  Copyright 2006 Positive Spin Media. All rights reserved.
//

#import "PSMRegistrationController.h"
#import "PSMAppController.h"


@implementation PSMRegistrationController

- (void)runRegPanel:(id)sender
{
    // clicked the button to pay me - confirmation message
    [NSApp beginSheet: [self window]
       modalForWindow: [NSApp mainWindow]
        modalDelegate: nil
       didEndSelector: nil
          contextInfo: nil];
    [NSApp runModalForWindow: [self window]];
    // Sheet is up here.
    [NSApp endSheet:[self window]];
    [[self window] orderOut:self];
}

- (IBAction)cancelRegistration:(id)sender
{
    // user cancelled
    [NSApp stopModal];
}

- (IBAction)verifyRegistration:(id)sender
{
    // UI
    [regIndicator setHidden:NO];
    [regIndicator startAnimation:self];
    [regStatus setStringValue:@"Contacting server..."];
    [regStatus setHidden:NO];
    
    // get response
    NSError *error;
    NSString *responseString, *messageString;
    NSArray *responsePieces;
    NSURLResponse* resp;
    NSData* data;
    NSString *regURL = [[NSString stringWithFormat:@"http://www.positivespinmedia.com/shareware/Pandora/p2reg.php?firstName=%@&lastName=%@&regCode=%@&email=%@", [firstName stringValue], [lastName stringValue], [regCode stringValue], [emailAddress stringValue]] stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding];
    // old stringWithContentsOfURL gags on potentially gzipped data return
    // if(responseString = [NSString stringWithContentsOfURL:[NSURL URLWithString:regURL] usedEncoding:&enc error:&error]){
    NSURLRequest* req = [NSURLRequest requestWithURL:[NSURL URLWithString:regURL]];
    data = [NSURLConnection sendSynchronousRequest:req returningResponse:&resp error:&error];
    
    if(responseString = [[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding]){
        responsePieces = [responseString componentsSeparatedByString:@"~"];
        messageString = [responsePieces objectAtIndex:0];
    } else {
        messageString = [NSString stringWithFormat:@"Could not contact server... please retry later.  Error: %@", error];
    }
    [regStatus setStringValue:messageString];
    [responseString release];
    // size window to accomodate response message
    int currentFieldH = [regStatus frame].size.height;
    int newTextH = [[[regStatus cell] attributedStringValue] boundingRectWithSize:[regStatus frame].size options:NSStringDrawingUsesLineFragmentOrigin].size.height;
    NSRect newRect = [[self window] frame];
    int diff = newTextH - currentFieldH;
    newRect.size.height = newRect.size.height + diff;
    newRect.origin.y = newRect.origin.y - diff;
    [[self window] setFrame:newRect display:YES animate:YES];
    
    // perform registration internally if needed
    if([messageString rangeOfString:@"Thanks!"].length != 0){
        NSArray *searchPaths = NSSearchPathForDirectoriesInDomains(NSApplicationSupportDirectory, NSLocalDomainMask | NSUserDomainMask, YES);
        NSEnumerator *e = [searchPaths objectEnumerator];
        NSString *specificPath;
        while(specificPath = [e nextObject]){
            NSString *machineLicenseFile = [specificPath stringByAppendingPathComponent:@"Pandora/.com.positivespinmedia.Pandora.license"];
            NSDictionary *regDict = [NSDictionary dictionaryWithObjectsAndKeys:[regCode stringValue], @"registration code", [emailAddress stringValue], @"email address", [responsePieces objectAtIndex:1], @"first name", [responsePieces objectAtIndex:2], @"last name", nil];
            [regDict writeToFile:machineLicenseFile atomically:YES];
        }
        // UI
        [closeButton setTitle:@"Done"];
        [[self window] setDefaultButtonCell:[closeButton cell]];
        // nuke purchase menu
        [[NSApp mainMenu] removeItem:[[NSApp mainMenu] itemWithTag:4]];
        [[NSApp delegate] setIsRegistered:YES];
        [[NSApp delegate] setCanDropToFinder:YES];
    }
    
    // UI
    [regIndicator stopAnimation:self];
    [regIndicator setHidden:YES];
}

@end
