//
//  PSMPopUpButtonCell.m
//  NetScrape
//
//  Created by John Pannell on 10/25/05.
//  Copyright 2005 Positive Spin Media. All rights reserved.
//

#import "PSMPopUpButtonCell.h"


@implementation PSMPopUpButtonCell

- (void)drawInteriorWithFrame:(NSRect)cellFrame inView:(NSView *)controlView
{
    // draw the interior of the cell
    // textured background
    NSRect interiorRect = cellFrame;
    interiorRect.size.height -= 2.0;
    interiorRect.origin.y += 1.0;
    NSColor *cellBG = [NSColor colorWithPatternImage:[NSImage imageNamed:@"texturedCell"]];
    [cellBG set];
    [[NSGraphicsContext currentContext] setPatternPhase:NSMakePoint(0,13)]; // why?
    NSRectFill(interiorRect);
    
    // arrows
    NSBezierPath *path = [NSBezierPath bezierPath];
    [path moveToPoint:NSMakePoint(NSMaxX(cellFrame) - 7.5, NSMidY(cellFrame) - 5.5)];
    [path relativeLineToPoint:NSMakePoint(-2.5,4.0)];
    [path relativeLineToPoint:NSMakePoint(5.0,0.0)];
    [path closePath];
    [path relativeMoveToPoint:NSMakePoint(0.0,11.0)];
    [path relativeLineToPoint:NSMakePoint(2.5,-4.0)];
    [path relativeLineToPoint:NSMakePoint(-5.0,0.0)];
    [path closePath];
    [[NSColor blackColor] set];
    [path fill];
    
    // text contents of cell
    NSDictionary *attributes = [NSDictionary dictionaryWithObjectsAndKeys:[NSFont systemFontOfSize:9], NSFontAttributeName, nil];
    [controlView lockFocus];
    [[(NSPopUpButton *)controlView titleOfSelectedItem] drawAtPoint:NSMakePoint(interiorRect.origin.x + 5.0, interiorRect.origin.y) withAttributes:attributes];
    [controlView unlockFocus];
    
    // line at the end
    NSBezierPath *path2 = [NSBezierPath bezierPath];
    [path2 moveToPoint:NSMakePoint(cellFrame.size.width,0)];
    [path2 relativeLineToPoint:NSMakePoint(0,cellFrame.size.height)];
    [[NSColor darkGrayColor] set];
    [path2 stroke];
}

@end
