//
//  PSMTexturedTextFieldCell.m
//  NetScrape
//
//  Created by John Pannell on 10/25/05.
//  Copyright 2005 Positive Spin Media. All rights reserved.
//

#import "PSMTexturedTextFieldCell.h"


@implementation PSMTexturedTextFieldCell

- (void)drawInteriorWithFrame:(NSRect)cellFrame inView:(NSView *)controlView
{
    // draw the interior of the cell
    // textured background
    NSRect interiorRect = cellFrame;
    interiorRect.size.height -= 2.0;
    interiorRect.origin.y += 1.0;
    NSColor *cellBG = [NSColor colorWithPatternImage:[NSImage imageNamed:@"texturedCell"]];
    [cellBG set];
    [[NSGraphicsContext currentContext] setPatternPhase:NSMakePoint(0,13)]; // why?
    NSRectFill(interiorRect);
    
    // text contents of cell - centered
    // calculate width
    NSMutableAttributedString*  attrStr;
    attrStr=[[[NSMutableAttributedString alloc]initWithString:[(NSTextField *)controlView stringValue]] autorelease];
    NSRange range=NSMakeRange(0, [[(NSTextField *)controlView stringValue] length]);
    [attrStr addAttribute:NSFontAttributeName value:[NSFont systemFontOfSize:9] range:range];
    float   offset = [attrStr size].width;
    
    NSDictionary *attributes = [NSDictionary dictionaryWithObjectsAndKeys:[NSFont systemFontOfSize:9], NSFontAttributeName, nil];
    [controlView lockFocus];
    [[(NSTextField *)controlView stringValue] drawAtPoint:NSMakePoint((interiorRect.size.width - offset)/2.0, interiorRect.origin.y) withAttributes:attributes];
    [controlView unlockFocus];
    
    // line around control
    NSBezierPath *path2 = [NSBezierPath bezierPath];
    [path2 moveToPoint:NSMakePoint(cellFrame.origin.x,0)];
    [path2 relativeLineToPoint:NSMakePoint(cellFrame.size.width,0)];
    [path2 relativeLineToPoint:NSMakePoint(0,cellFrame.size.height)];
    [path2 relativeLineToPoint:NSMakePoint(-cellFrame.size.width,0)];
    [[NSColor darkGrayColor] set];
    [path2 stroke];
}


@end
