//
//  PSMVerticallyCenteredTextFieldCell.m
//  Pandora
//
//  Created by John Pannell on 5/17/06.
//  Copyright 2006 Positive Spin Media. All rights reserved.
//

#import "PSMVerticallyCenteredTextFieldCell.h"


@implementation PSMVerticallyCenteredTextFieldCell
- (void)drawInteriorWithFrame:(NSRect)cellFrame inView:(NSView *)controlView
{
    // draw text of cell centered vertically
    NSRect cellTextRect;
    float newHeight = [[self attributedStringValue] boundingRectWithSize:cellFrame.size options:NSStringDrawingUsesLineFragmentOrigin].size.height;
    if(newHeight <= cellFrame.size.height){
        cellTextRect.size.height = newHeight;
    } else {
        cellTextRect.size.height = cellFrame.size.height;
    }
    cellTextRect.size.width = cellFrame.size.width;
    cellTextRect.origin.x = cellFrame.origin.x;
    cellTextRect.origin.y = cellFrame.origin.y + (cellFrame.size.height - cellTextRect.size.height)/2.0;
    [super drawInteriorWithFrame:cellTextRect inView:controlView];
}
@end
