//
//  PSMWebBrowserButton.h
//  NetScrape
//
//  Created by John Pannell on 8/22/05.
//  Copyright 2005 Positive Spin Media. All rights reserved.
//

/*
    Overrides NSButton to provide enabled/disabled/mouseDown behavior like
    iTunes, Safari, etc.  In IB, set the button to "momentary change", and the alternate icon to the 
    mouseDown image.  In XCode, manually set the appropriate image for each instance variable.
 
*/

#import <Cocoa/Cocoa.h>


@interface PSMWebBrowserButton : NSButton {
    NSImage     *enabledImage;
    NSImage     *disabledImage;
}

// override to set image properly
- (void)setEnabled:(BOOL)flag;

// imitialize the images
- (void)setEnabledImage:(NSImage *)image;
- (void)setDisabledImage:(NSImage *)image;

@end
