//
//  PSMHTMLParser.h
//  Pandora
//
//  Created by John Pannell on 3/14/06.
//  Copyright 2006 Positive Spin Media. All rights reserved.
//

#import <Cocoa/Cocoa.h>
@class PSMWebResource;

@interface PSMHTMLParser : NSObject {
    
    // my stuff
    NSMutableData       *_htmldata;
    PSMWebResource      *_resource;
    
    // things I'm looking for
    NSSet               *_interestingTags;
    NSDictionary        *_interestingAttributes;
    
    // what I'm looking at
    NSString            *_sourceURL;
}

// creation/destruction
- (id)initWithHTMLData:(NSMutableData *)data fromResource:(PSMWebResource *)resource;
- (void)dealloc;

// accessors
- (NSMutableData *)htmldata;
- (void)setHTMLData:(NSMutableData *)data;
- (PSMWebResource *)resource;
- (void)setResource:(PSMWebResource *)resource;
- (NSString *)sourceURL;
- (void)setSourceURL:(NSString *)string;

// functionality
- (void)parse;
- (NSString *)findValueForAttribute:(NSString *)attribute inString:(NSString *)tagContents;

@end
