/*
 *  PandoraPlugin.h
 *  Pandora
 *
 *  Created by John Pannell on 12/16/05.
 *  Copyright 2005 Positive Spin Media. All rights reserved.
 *
 */

#import <Cocoa/Cocoa.h>

@protocol PandoraPlugin

// for identification
+ (NSImage *)icon;
+ (NSString *)name;
+ (NSString *)description;
+ (NSString *)category;
+ (NSString *)prompt;

// accessors
- (void)setMIMETypes:(NSSet *)types;
- (void)setMinFileSize:(int)kilobytes;
- (void)setMaxFileSize:(int)kilobytes;

// for spider
- (BOOL)contentFromDifferentServers;
- (int)linkDepth;
- (NSMutableArray *)preprocessURLOrKeyword:(NSString *)string;
- (BOOL)shouldPursueResourceWithURL:(NSString *)url MIMEType:(NSString *)mime andExpectedFileSize:(long long)size withReason:(NSString **)reason;
- (NSDictionary *)postprocessURL:(NSString *)url;

// authentication
- (NSArray *)authenticationInfo;
- (BOOL)parseAuthSuccessPage;
- (NSString *)authSuccessURLFragment;

@end