/*
 *  main.m
 *  Pandora - PSMWebSpider sub-application
 *
 *  Created by John Pannell on 12/14/05.
 *  Copyright 2005 Positive Spin Media. All rights reserved.
 *
 */

#import <Cocoa/Cocoa.h>
#import "PSMWebSpider.h"
#import "PandoraSession.h"

#include <stdio.h>
#include <sys/time.h>
#include <sys/resource.h>

int main(int argc, char *argv[])
{
    if (argc < 2) {
        NSLog(@"missing arguments!");
        exit(1);
    }
    
    NSAutoreleasePool * pool = [[NSAutoreleasePool alloc] init];
    
    // don't allow stdout to buffer messages back to parent app!!!
    setvbuf(stdout, NULL, _IONBF, 0);
    
    // crank down priority
    setpriority(PRIO_PROCESS, [[NSProcessInfo processInfo] processIdentifier], 20);
    
    PSMWebSpider *spider = [[PSMWebSpider alloc] init];
    //NSLog(@"main: spider = %@", spider);
    
    // vend spider object over connection
    NSConnection *theConnection = [NSConnection defaultConnection];
    //NSLog(@"main: connection = %@", theConnection);
    [theConnection setRootObject:spider];
    if(![theConnection registerName:[[[NSProcessInfo processInfo] arguments] objectAtIndex:3]])
        NSLog(@"couldn't register connection name");
    // tell host application
    printf("running: %s\n", [[[[NSProcessInfo processInfo] arguments] objectAtIndex:3] cString]);
    
    // Start the runloop
    [[NSApplication sharedApplication] run];
    
    // If the run loop exits (and I do not know why it would), cleanup
    [theConnection registerName:nil];
    [pool release];
    return 0;
}
